import { AnyAction } from 'redux';
import { FunctionProducer } from '../utils/function_producer';
import { PodInstance, ActionCreator, InternalProxiedAction, ProxiedActionMembers } from '../internal/interfaces';
export declare class ProxiedAction<A extends ActionCreator> extends FunctionProducer<ProxiedActionMembers<A>, InternalProxiedAction<A>> {
    private type;
    private instance;
    private actionCreator;
    constructor(type: string, instance: PodInstance, actionCreator: A);
    getType(): string;
    getActionCreator(): A;
    getBaseAction(): {
        type: string;
        path: string;
    };
    proxiedStatefulAction(args: any): {
        arguments: any;
        type: string;
        path: string;
    };
    proxiedBasicAction(args: any): {
        type: string;
        path: string;
    } | {
        type: string;
        path: string;
    };
    process(state: any, action: ReturnType<InternalProxiedAction<A>>): void | {};
    match(action: AnyAction): boolean;
    clone(instance: PodInstance): ProxiedAction<A>;
    boundFunctionMembers(): ProxiedActionMembers<A>;
}
