"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(require("./internal/module"));
var reducer_1 = require("./reducer/reducer");
var properties_1 = require("./reducer/properties");
var enhancer_1 = require("./internal/enhancer");
/**
 * The root pod creator function overload handler.
 *
 * @param initialState The initial reducer state obj.
 * @param stateResetActionKey The state reset action key.
 */
exports.rootPodCreator = function (initialState, stateResetActionKey) {
    var _a;
    if (initialState === null || typeof initialState === 'function') {
        throw new Error("Invalid initial state of type " + typeof initialState + ". Expected object or primitive.");
    }
    var suppliedStateResetKey = stateResetActionKey !== undefined;
    if (suppliedStateResetKey &&
        (typeof stateResetActionKey !== 'string' ||
            stateResetActionKey.length === 0)) {
        throw new Error("Invalid state reset action key of type " + typeof stateResetActionKey + ". Expected string.");
    }
    var props = new properties_1.PodProperties({ initialState: initialState, actionSet: {} });
    var pod = new reducer_1.PodReducer(props).getBoundFunc();
    return !suppliedStateResetKey
        ? pod
        : pod.on((_a = {},
            _a[stateResetActionKey] = function () { return function () { return initialState; }; },
            _a));
};
exports.rootPodCreator.enhancer = enhancer_1.reduxPodEnhancer;
exports.default = exports.rootPodCreator;
