"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * A class used to hold a pending obj value. Used by the pod enhancer function
 * to temporarily wrap the initial state of pod reducers when the store is being
 * created, and subsequently detect it's location within the redux state tree.
 *
 * @interface T The pending obj type
 */
var PendingValue = /** @class */ (function () {
    /**
     * Pending Value constructor function.
     *
     * @param pendingVal The pending value to hold of type `T`
     */
    function PendingValue(pendingVal) {
        this.pendingVal = pendingVal;
    }
    /**
     * Get the original obj. passed to the constructor.
     */
    PendingValue.prototype.valueOf = function () {
        return this.pendingVal;
    };
    return PendingValue;
}());
exports.PendingValue = PendingValue;
